IKEv1 বনাম IKEv2: পূর্ব-শেয়ার করা কী দিয়ে প্রমাণীকরণে কী আলাদা
দুটি সংস্করণই পূর্ব-শেয়ার করা কী পাঠানো ছাড়াই তা জানার প্রমাণ দেয়, কিন্তু তারা ভিন্ন ইনপুট ভিন্ন হ্যাশে দেয়। দুটি ট্রেস তুলনা করুন।
একই পূর্ব-শেয়ার করা কী দিয়ে কনফিগার করা দুটি গেটওয়ে একটি হ্যান্ডশেক সম্পন্ন করে, এবং প্যাকেট ক্যাপচার দেখায় যে কোনো গোপন তথ্য তারের ওপর দিয়ে যায় না। এটাই মানুষ মনে রাখে। মজার অংশ হলো প্রতিটি সংস্করণ আসলে কী গণনা করে প্রমাণ করে যে গোপন তথ্যটি জানা আছে, কারণ IKEv1 ও IKEv2 ভিন্ন ইনপুট থেকে সেই প্রমাণ তৈরি করে এবং তা করতে গিয়ে ভিন্ন তথ্য প্রকাশ করে। দুটি ট্রেস পাশাপাশি পড়ুন, পার্থক্য আর কেবল বাহ্যিক থাকে না।
প্রমাণটিকে কী অর্জন করতে হবে
ডিফি-হেলম্যান উভয় পক্ষকে একটি সাধারণ মান দেয়, যার প্রকাশ্য অর্ধেক যে কেউ দেখছে সে-ও গণনা করতে পারে। এটি নিজে থেকে পরিচয় সম্পর্কে কিছু প্রমাণ করে না: যে আক্রমণকারী একটি কী বিনিময় সম্পন্ন করে, তারও আপনার গেটওয়ের মতো একই সাধারণ মান থাকে। প্রমাণীকরণ ধাপটি আছে সেই বিনিময়কে এমন একটি গোপন তথ্যের সঙ্গে বাঁধতে যা কেবল উদ্দিষ্ট পক্ষগুলোর কাছে আছে, এবং তারা যে পরিচয় ও প্যারামিটারে সম্মত হয়েছে তার সঙ্গেও।
এই বাঁধনই কারণ হ্যাশটি কী-এর চেয়ে বেশি কিছু ঢাকে। যদি এটি কেবল গোপন তথ্যটি ঢাকত, তবে আক্রমণকারী ভিন্ন পরিচয় বা প্রস্তাবসহ অন্য বিনিময়ে এটি পুনরায় চালাতে পারত।
IKEv1 প্রধান মোড: SKEYID তৈরি করুন, তারপর প্রমাণ করুন
প্রধান মোড ছয়টি বার্তা চালায়। প্রথম জোড়া নিরাপত্তা অ্যাসোসিয়েশন নিয়ে দরকষাকষি করে, দ্বিতীয়টি ডিফি-হেলম্যান প্রকাশ্য মান ও নন্স বিনিময় করে, আর তৃতীয়টি সদ্য প্রতিষ্ঠিত এনক্রিপশনের অধীনে পরিচয় ও প্রমাণীকরণ হ্যাশ বহন করে। RFC 2409 এই গঠনটি নির্ধারণ করে: পূর্ব-শেয়ার করা কী প্রমাণীকরণে SKEYID গোপন তথ্য ও উভয় নন্স থেকে উদ্ভূত হয়, এবং পরবর্তী কী উপাদান SKEYID, ডিফি-হেলম্যান সাধারণ মান, কুকি ও ধ্রুবক থেকে উদ্ভূত হয়।
পাঁচ ও ছয় নম্বর বার্তার হ্যাশ ডিফি-হেলম্যান মান, দুটি কুকি, প্রস্তাব ও প্রেরকের পরিচয়ের ওপর SKEYID দিয়ে গণনা করা হয়। গ্রহীতা নিজের কনফিগার করা গোপন তথ্য দিয়ে এটি পুনরায় গণনা করে। অমিল বিনিময়টি শেষ করে দেয়, এবং কোনো সময়েই গোপন তথ্য নিজে পেলোড হয় না।
আক্রমণাত্মক মোড একই কাজ তিনটি বার্তায় সংকুচিত করে, অর্থাৎ এনক্রিপ্টেড চ্যানেল তৈরির আগেই পরিচয় ও প্রমাণীকরণ হ্যাশ যাতায়াত করে। অনুমানযোগ্য গোপন তথ্যের জন্য এটি বাস্তব ঝুঁকি, এবং গোপন তথ্য পাঠানো হয়েছিল কি না সেই প্রশ্ন থেকে এটি আলাদা। RFC 9395 IKEv1-কে অপ্রচলিত করেছে, তাই পুরোনো ট্রেস একটি রোগনির্ণয়ের অনুশীলন, কোনো স্থাপনার লক্ষ্য নয়।
IKEv2: ভিন্ন উদ্ভব ও ভিন্ন AUTH পেলোড
IKEv2 IKEv1-এর কী সূচি পুনরায় ব্যবহার করে না। প্রাথমিক IKE কী আসে নন্স ও ডিফি-হেলম্যান সাধারণ মান থেকে গড়া একটি বীজ থেকে, এবং চাইল্ড নিরাপত্তা অ্যাসোসিয়েশনগুলো তা থেকেই উদ্ভূত হয়। পূর্ব-শেয়ার করা কী বীজে একেবারেই যায় না।
এরপর প্রমাণীকরণ AUTH পেলোড হিসেবে আসে। শেয়ার করা কী প্রমাণীকরণের জন্য RFC 7296 গোপন তথ্যের একটি প্যাডেড রূপ নির্ধারণ করে, যা গোপন তথ্যকে নির্দিষ্ট স্ট্রিং Key Pad for IKEv2 দিয়ে হ্যাশ করে, তারপর স্বাক্ষরিত বিনিময় ডেটা ও পরিচয়কে সেই প্যাডেড কী দিয়ে হ্যাশ করে তৈরি হয়। যাচাইকারী একই মান পুনর্গঠন করতে পারে; পর্যবেক্ষক গোপন তথ্য ছাড়া পারে না।
কী বদলাল লক্ষ্য করুন। IKEv1-এ প্রমাণীকরণ হ্যাশ তৈরির আগেই গোপন তথ্য কী সূচিতে গাঁথা হয়; IKEv2-তে কী সূচি গোপন তথ্য থেকে স্বাধীন এবং প্রমাণটি স্বাক্ষরিত অক্টেটের সঙ্গে বাঁধা আলাদা পেলোড। একই ধারণাগত নিশ্চয়তা, ভিন্ন যন্ত্রকৌশল, আর তাই প্যারামিটারের নাম ও ক্যাপচার একের সঙ্গে একে মেলে না।
পর্যবেক্ষক আসলে কী জানতে পারে
ডিফি-হেলম্যান প্রকাশ্য মান, প্রস্তাব, নন্স ও কুকি দুই সংস্করণেই দৃশ্যমান। পরিচয় দৃশ্যমান IKEv1 আক্রমণাত্মক মোড-এ এবং অন্য ক্ষেত্রে সুরক্ষিত। গোপন তথ্য কখনোই দৃশ্যমান নয়।
শেষ বাক্যটির একটি সীমা আছে যা বলা দরকার। দুর্বল, মানুষ-নির্বাচিত গোপন তথ্য অনুমান করে আক্রমণ করা যায়: আক্রমণকারী কোনো প্রার্থী গোপন তথ্যের জন্য প্রমাণীকরণ মান কী হবে তা গণনা করে তুলনা করে। IKEv1 আক্রমণাত্মক মোড এটিকে সবচেয়ে সস্তা করে, কারণ প্রমাণ খোলা থাকে, এবং মানদণ্ড সাধারণভাবে নিম্ন-এনট্রপি গোপন তথ্য সম্পর্কে সতর্ক করে। গোপন তথ্য কখনো না পাঠানো আর খারাপ গোপন তথ্যকে নিরাপদ করা এক নয়।
তুলনাটি নিয়ে কী করবেন
প্রতিটি পক্ষ-জোড়ার জন্য একটি অনন্য গোপন তথ্য ব্যবহার করুন, তা কোনো এলোমেলো উৎস থেকে তৈরি করুন, এবং যে সরবরাহ পথ এটি বিতরণ করেছিল সেই পথেই তা ঘোরান। যদি গোপন তথ্য এমন একটি কনফিগারেশন টেমপ্লেটে রাখা থাকে যা প্রতিটি শাখায় পাঠানো হয়, তবে এক জায়গায় আপস সব জায়গায় আপস।
যেখানে পরিচালন ব্যয় গ্রহণযোগ্য সেখানে সার্টিফিকেট-ভিত্তিক প্রমাণীকরণ পছন্দ করুন, কারণ এটি শেয়ার করা গোপন তথ্য অনুমানের সমস্যা সরিয়ে দেয় এবং প্রতিটি পক্ষকে আলাদা পরিচয় দেয়। যেখানে পূর্ব-শেয়ার করা কী থাকে, সেখানে তা লম্বা রাখুন, পরিধি সংকীর্ণ করুন এবং IKE সংস্করণকে আন্তঃকার্যক্ষমতার খুঁটিনাটি নয়, নিরাপত্তার সিদ্ধান্ত হিসেবে দেখুন।